package tictactoe.learn;

import static org.junit.Assert.*;

import java.util.ArrayList;

import org.junit.Test;

public class HashTableTest {
	HashTable<String,Integer> table = new HashTable<>();
	
	String[] keys = new String[]{"this", "is", "a", "test", "to", "check", "how", "it", 
			"works", "in", "practice", "with", "many", "different", "keys", "included", 
			"within", "the", "table"};

	@Test
	public void testAddContains() {
		for (String key: keys) {
			assertFalse(table.containsKey(key));
			int oldSize = table.size();
			table.put(key, key.length());
			assertEquals(oldSize + 1, table.size());
			assertTrue(table.containsKey(key));
		}
		
		assertEquals(keys.length, table.size());
		
		for (String key: keys) {
			assertTrue(table.containsKey(key));
			assertTrue(key.length() == table.get(key));
		}
	}
	
	@Test
	public void testDuplicate() {
		testAddContains();
		for (String key: keys) {
			int oldSize = table.size();
			table.put(key, key.length() * 2);
			assertEquals(oldSize, table.size());
			assertTrue(table.containsKey(key));
			assertTrue(key.length() * 2 == table.get(key));
		}
		
		assertEquals(keys.length, table.size());
		
		for (String key: keys) {
			assertTrue(table.containsKey(key));
			assertTrue(key.length() * 2 == table.get(key));
		}
	}

	@Test
	public void testKeys() {
		testAddContains();
		ArrayList<String> allKeys = table.allKeys();
		assertEquals(keys.length, allKeys.size());
		for (String key: keys) {
			assertTrue(table.allKeys().contains(key));
		}
	}
}
